com.hazelcast.jet.core

## Class JetProperties

- java.lang.Object
- - com.hazelcast.jet.core.JetProperties

-     public final class JetProperties
      extends Object

  Defines the names and default values for internal Hazelcast Jet properties.
  Since:
    3.2

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static HazelcastProperty` | `JET_HOME` Root of Jet installation.
    `static HazelcastProperty` | `JET_IDLE_COOPERATIVE_MAX_MICROSECONDS` The maximum time in microseconds the cooperative worker threads will sleep if none of the tasklets made any progress.
    `static HazelcastProperty` | `JET_IDLE_COOPERATIVE_MIN_MICROSECONDS` The minimum time in microseconds the cooperative worker threads will sleep if none of the tasklets made any progress.
    `static HazelcastProperty` | `JET_IDLE_NONCOOPERATIVE_MAX_MICROSECONDS` The maximum time in microseconds the non-cooperative worker threads will sleep if none of the tasklets made any progress.
    `static HazelcastProperty` | `JET_IDLE_NONCOOPERATIVE_MIN_MICROSECONDS` The minimum time in microseconds the non-cooperative worker threads will sleep if none of the tasklets made any progress.
    `static HazelcastProperty` | `JET_SHUTDOWNHOOK_ENABLED` Whether a JVM shutdown hook is registered to shutdown the node gracefully when the process is terminated.
    `static HazelcastProperty` | `JOB_RESULTS_MAX_SIZE` Maximum number of job results to keep in the cluster, the oldest results will be automatically deleted after this size is reached.
    `static HazelcastProperty` | `JOB_RESULTS_TTL_SECONDS` Maximum number of time in seconds the job results will be kept in the cluster.
    `static HazelcastProperty` | `JOB_SCAN_PERIOD` Jet will periodically check for new jobs to start and perform cleanup of unused resources.

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### JOB_SCAN_PERIOD

          public static final HazelcastProperty JOB_SCAN_PERIOD

      Jet will periodically check for new jobs to start and perform cleanup of unused resources. This property configures how often this check and cleanup will be done. Value is in milliseconds.
      Since:
        3.2

    - #### JET_SHUTDOWNHOOK_ENABLED

          public static final HazelcastProperty JET_SHUTDOWNHOOK_ENABLED

      Whether a JVM shutdown hook is registered to shutdown the node gracefully when the process is terminated. The shutdown hook will terminate all running jobs and then gracefully terminate the note, in a way that is equivalent to calling `JetInstance.shutdown()`.
      Since:
        3.2

    - #### JOB_RESULTS_TTL_SECONDS

          public static final HazelcastProperty JOB_RESULTS_TTL_SECONDS

      Maximum number of time in seconds the job results will be kept in the cluster. They will be automatically deleted after this period is reached.

      Default value is 7 days.

      Since:
        3.2

    - #### JOB_RESULTS_MAX_SIZE

          public static final HazelcastProperty JOB_RESULTS_MAX_SIZE

      Maximum number of job results to keep in the cluster, the oldest results will be automatically deleted after this size is reached.

      Default value is 1,000 jobs.

      Since:
        3.2

    - #### JET_HOME

          public static final HazelcastProperty JET_HOME

      Root of Jet installation. Used as default location for the lossless recovery store. By default it will be automatically set to the start of the Jet installation path.
      Since:
        3.2

    - #### JET_IDLE_COOPERATIVE_MIN_MICROSECONDS

          public static final HazelcastProperty JET_IDLE_COOPERATIVE_MIN_MICROSECONDS

      The minimum time in microseconds the cooperative worker threads will sleep if none of the tasklets made any progress. Lower values increase idle CPU usage but may result in decreased latency. Higher values will increase latency and very high values (>10000µs) will also limit throughput.

      The default is value is `25µs`.

      Note: the underlying `LockSupport.parkNanos(long)` call may actually sleep longer depending on the operating system (up to 15000µs on Windows). See the Hazelcast blog post about this subject for more details.

      See also: `JET_IDLE_COOPERATIVE_MAX_MICROSECONDS`

      Since:
        3.2

    - #### JET_IDLE_COOPERATIVE_MAX_MICROSECONDS

          public static final HazelcastProperty JET_IDLE_COOPERATIVE_MAX_MICROSECONDS

      The maximum time in microseconds the cooperative worker threads will sleep if none of the tasklets made any progress. Lower values increase idle CPU usage but may result in decreased latency. Higher values will increase latency and very high values (>10000µs) will also limit throughput.

      The default is value is `500µs`.

      Note: the underlying `LockSupport.parkNanos(long)` call may actually sleep longer depending on the operating system (up to 15000µs on Windows). See the Hazelcast blog post about this subject for more details.

      See also: `JET_IDLE_COOPERATIVE_MIN_MICROSECONDS`

      Since:
        3.2

    - #### JET_IDLE_NONCOOPERATIVE_MIN_MICROSECONDS

          public static final HazelcastProperty JET_IDLE_NONCOOPERATIVE_MIN_MICROSECONDS

      The minimum time in microseconds the non-cooperative worker threads will sleep if none of the tasklets made any progress. Lower values increase idle CPU usage but may result in decreased latency. Higher values will increase latency and very high values (>10000µs) will also limit throughput.

      The default is value is `25µs`.

      Note: the underlying `LockSupport.parkNanos(long)` call may actually sleep longer depending on the operating system (up to 15000µs on Windows). See the Hazelcast blog post about this subject for more details.

      See also: `JET_IDLE_NONCOOPERATIVE_MAX_MICROSECONDS`

      Since:
        3.2

    - #### JET_IDLE_NONCOOPERATIVE_MAX_MICROSECONDS

          public static final HazelcastProperty JET_IDLE_NONCOOPERATIVE_MAX_MICROSECONDS

      The maximum time in microseconds the non-cooperative worker threads will sleep if none of the tasklets made any progress. Lower values increase idle CPU usage but may result in decreased latency. Higher values will increase latency and very high values (>10000µs) will also limit throughput.

      The default is value is `5000µs`.

      Note: the underlying `LockSupport.parkNanos(long)` call may actually sleep longer depending on the operating system (up to 15000µs on Windows). See the Hazelcast blog post about this subject for more details.

      See also: `JET_IDLE_NONCOOPERATIVE_MIN_MICROSECONDS`

      Since:
        3.2

Copyright © 2020. All rights reserved.